local shit = {}

shit.pieces = {}

shit.pieceimg = love.graphics.newImage("piece.png")
shit.pieceox = shit.pieceimg:getWidth() * 0.5
shit.pieceoy = shit.pieceimg:getWidth() * 0.5

shit.splatimg = love.graphics.newImage("splat.png")
shit.splatox = shit.splatimg:getWidth() * 0.5
shit.splatoy = shit.splatimg:getWidth() * 0.5

shit.sbindex = 0
shit.count = 0

function shit:update()
	for i = #self.pieces, 1, -1 do
		local p = self.pieces[i]
		local x, y = p.b:getPosition()
		if
			p.remove or
			x + 2 < game.world.boundaries.left or
			x - 2 > game.world.boundaries.right or
			y > game.world.boundaries.bottom
		then
			p.b:destroy()
			table.remove(self.pieces, i)
		end
	end
end

function shit:draw()
	for i = 1, #self.pieces do
		local p = self.pieces[i]
		love.graphics.draw(self.pieceimg, p.b:getX() * game.scale, p.b:getY() * game.scale, p.b:getAngle(), 0.02 * game.scale, 0.02 * game.scale, self.pieceox, self.pieceoy)
	end
end

function shit:addPiece(x, y, vx, vy)
	local p = {}
	p.b = love.physics.newBody(game.world.world, x + vx * 0.3, y + vy * 0.3, "dynamic")

	p.s = love.physics.newCircleShape(0.3)
	p.f = love.physics.newFixture(p.b, p.s)
	p.f:setGroupIndex(-1)
	p.f:setUserData("poop")

	local speed = math.random() * 10 + 10
	local pvx, pvy = game.world.pig.b:getLinearVelocity()
	p.b:setLinearVelocity(-vx * speed + pvx, -vy * speed + pvy)
	p.b:setAngle(math.atan2(vy, vx) + math.pi/2)

	table.insert(self.pieces, p)
end

function shit:hit(fix, x, y)
	for i = 1, #self.pieces do
		local p = self.pieces[i]
		if p.f == fix then
			shit:addSplat(game.world.terrain.b:getWorldPoints(x, y))
			p.remove = true
		end
	end
end

function shit:addSplat(x, y)
	local pr, psx, psy = math.random() * math.pi * 2, math.random() + 0.5, math.random() * 0.02 + 0.04
	self.sb:setColor(255, 255, 255, math.random(130, 200))
	if self.count == 500 then
		self.sb:set(shit.sbindex, x, y, pr, psy, psy, self.splatox, self.splatoy)
	else
		self.sb:add(x, y, pr, psy, psy, self.splatox, self.splatoy)
		self.count = self.count + 1
	end

	self.sbindex = (self.sbindex + 1)%500
end

function shit:reset()
	self.sb = love.graphics.newSpriteBatch(shit.splatimg, 500)
	self.sbindex = 0
	self.count = 0
	for i = 1, #self.pieces do
		self.pieces[i].b:destroy()
		self.pieces[i] = nil
	end
end

return shit
