local sound = {}

sound.list = {}
sound.list.death = {}
sound.list.death[1] = love.audio.newSource("snd/death1.ogg")
sound.list.death[2] = love.audio.newSource("snd/death2.ogg")
sound.list.death[3] = love.audio.newSource("snd/death3.ogg")
sound.list.harddeath = {}
sound.list.harddeath[1] = love.audio.newSource("snd/harddeath1.ogg")
sound.list.harddeath[2] = love.audio.newSource("snd/harddeath2.ogg")
sound.list.harddeath[3] = love.audio.newSource("snd/harddeath3.ogg")
sound.list.beep = {}
sound.list.beep[1] = love.audio.newSource("snd/beep.ogg")
sound.list.happy = {}
sound.list.happy[1] = love.audio.newSource("snd/happy.ogg")

function sound:death()
	local snd = self.list.death[math.random(#self.list.death)]
	snd:setPitch(math.random()*0.2 + 1)
	snd:play()
end

function sound:harddeath()
	local snd = self.list.harddeath[math.random(#self.list.death)]
	snd:setPitch(math.random()*0.2 + 1)
	snd:play()
end

function sound:beep(pitch)
	local snd = self.list.beep[1]
	snd:setPitch(pitch)
	snd:play()
end

function sound:happy()
	local snd = self.list.happy[1]
	snd:setPitch(math.random()*0.2 + 1)
	snd:play()
end

return sound
