local terrain = {}
terrain.shit = require("shit")

local NUM_POINTS = 250
local POINT_OFFSET = -50
local POINT_SPACING = 1

local TERRAIN_OFFSET = 150
local TERRAIN_HEIGHT = 80
--local TERRAIN_ROUGHNESS = 0.5

local rnd = math.random
local rndh = function() return rnd() - 0.5 end

local polygon = love.graphics.polygon
function terrain:drawLand()
	local p = self.points
	for i = 1, #self.points - 2, 2 do
		polygon("fill", scaler(game.scale, p[i], p[i+1], p[i+2], p[i+3], p[i+2], 400, p[i], 400))
	end
end

function terrain:generate()
	local points = { rndh(), rndh() }

	local s = 2
	repeat
		local decay = s
		for i = #points * 2, 3, -2 do
			local p = i/2
			points[i-1] = points[p] + rndh() / decay
			points[i-2] = (points[p-1] + points[p]) * 0.5 + rndh() / decay
		end
		points[1] = points[1] + rndh() / decay
		s = s * 2 - 1
	until s >= NUM_POINTS

	local tmp = {}
	linear(points, tmp, NUM_POINTS)

	local max = 0
	for i = 1, #tmp do
		max = math.max(max, math.abs(tmp[i]))
	end
	local norm = 0.5 / max

	self.points = {}
	for i = 1, NUM_POINTS * 2, 2 do
		self.points[i] = (i + POINT_OFFSET - 1) * POINT_SPACING
		self.points[i+1] = TERRAIN_OFFSET + TERRAIN_HEIGHT * tmp[(i+1)/2] * norm
	end

	self.shit:reset()
	game.world.pig.bacon:reset()
end

local stencfunc = function() game.world.terrain:drawLand() end
function terrain:draw()
	self.shit:update()
	love.graphics.setStencil(stencfunc)

	love.graphics.setColor(0, 150, 0)
	love.graphics.rectangle("fill", -1000, -1000, 40000, 40000)

	love.graphics.push()
	love.graphics.scale(8*game.scale)
	love.graphics.setColor(0, 100, 0, 250)
	love.graphics.line(scaler(1/8, self.points))
	love.graphics.pop()

	love.graphics.setLineWidth(4)
	love.graphics.setColor(100, 50, 0)
	love.graphics.line(scaler(game.scale, self.points))
	love.graphics.setLineWidth(1)

	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(self.shit.sb, 0, 0, 0, game.scale, game.scale)

	love.graphics.setStencil()

	self.shit:draw()
end

return terrain
